import React from "react";
import Head from "next/head";
import Link from "next/link";
import { Button, Typography } from "@material-ui/core";
import { makeStyles } from "@material-ui/core/styles";
import Paper from "@material-ui/core/Paper";
import Layout from "../../../../components/admin/Layout";
import AddIcon from "@material-ui/icons/Add";
import ProductsTable from "../../../../components/admin/products/list/ProductsTable";
import xantiayadakAPI from "../../../../apis/xantiayadak";
import AuthProvider from "../../../../components/AuthProvider";

const useStyles = makeStyles((theme) => ({
  root: {
    width: "100%",
    padding: "20px",
  },
  addBtn: {
    "& .MuiButton-startIcon": {
      marginLeft: "10px",
    },
  },
  title: {
    textAlign: "center",
    margin: "20px",
    fontSize: "32px",
    textShadow: `1px 1px 5px ${theme.palette.primary.main}`,
  },
}));

export default function ProductsList(props) {
  const classes = useStyles();

  return (
    <>
      <Head>
        <title>لیست محصولات | پنل ادمین زانتیا یدک</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/xantia-logo-svg-vector.svg" />
      </Head>
      <Layout>
        <AuthProvider>
          <Paper className={classes.root}>
            <Link href="/admin/products/add-new-product">
              <a>
                <Button
                  className={classes.addBtn}
                  color="primary"
                  startIcon={<AddIcon />}
                >
                  افزودن محصول جدید
                </Button>
              </a>
            </Link>
            <Typography varinat="h1" className={classes.title}>
              لیست محصولات
            </Typography>
            <ProductsTable productsData={props.products} />
          </Paper>
        </AuthProvider>
      </Layout>
    </>
  );
}

export const getServerSideProps = async () => {
  const products = await xantiayadakAPI.get("/products");
  return {
    props: {
      products: products.data.data.map(
        ({ _id, name, price, discount, pictures }) => ({
          _id,
          name,
          price,
          discount,
          pictures,
        })
      ),
    },
  };
};
